#!/bin/sh

#cd to directory of script
cd `dirname $0` || exit 1

prompt () {
	eval $3=\"$2\"
	echo -n "$1 [$2]: "
	read tmp
	if [ -n "$tmp" ]; then
		eval $3=\"$tmp\"
	fi
}

ask_bool () {
	default=`eval echo '$'$2`
	if [ ! "$default" ]; then
		default=n
	fi
	answer=""
	while [ "$answer" != "n" -a "$answer" != "y" ]; do
		prompt "$1" "$default" answer
	done
	eval "$2=$answer"
}

hinweis () {
	echo "Now follow the QUICKSTART file. Happy newsreading!"
}

#root?
user=`id -u`
if [ "$user" == "0" ]; then
	ask_bool "You are root. This will no be a system-wide
		installation - you might do that manually -
		rather it installs vtticker only for user root in /root/.
		Do you really want to continue? (y/n)" ask_root
	if [ "$ask_root" == "n" ]; then
		exit 0
	fi
fi

echo "Installing files for knewsticker:"
mkdir -vp ~/.vtticker
mkdir -vp ~/.vtticker/temp
mkdir -vp ~/.vtticker/scripts
if [ ! -e ./vtticker ];then
	echo "Error: There is no file vtticker in" `pwd`". Exiting."
fi
cp -v ./vtticker ~/.vtticker/
cp -v ./vt-wrapper ~/.vtticker/
cp -v ./scripts/* ~/.vtticker/scripts/
test ! -e ~/.vtticker/options && touch ~/.vtticker/options
echo "Files installed."
echo "Now checking for necessary perl modules:"
echo "Module Video::XawTV..."
perl -e"use Video::XawTV" 2>/dev/null || { echo "Modul Video::XawTV nicht installiert";hinweis;exit 1; }
echo "installed"
echo "Module Video::Frequencies..."
perl -e"use Video::Frequencies" 2>/dev/null || { echo "Modul Video::Frequencies nicht installiert";hinweis;exit 1; }
echo "installed"
echo "Module Video::Capture::V4l..."
perl -e"use Video::Capture::V4l" 2>/dev/null || { echo "Modul Video::Capture::V4l nicht installiert";hinweis;exit 1; }
echo "installed"

echo "So far successfully installed."
hinweis
exit 0
