#!/usr/bin/perl

############################################################################
#    Copyright (c) 2002   Marcel Wiesweg <marcel@wiesweg-online.de>
#
#    This file is part of "vtticker"
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#############################################################################


use Getopt::Std;

#I want my !! Why doesn't it work?
#require 5.004;
#use locale;
#use POSIX qw (locale_h);
#setlocale(LC_CTYPE,"");

#this file provides a sample framework for scripts that transform video/teletext pages
#to rss embedded in the vtticker script which schedules, calls them and provides the grabbed pages.






#########################################################################################
# This is given to v4lctl. The manpage says						#
#       "setstation [ <name> | <nr> | next | prev | back ]				#
#              Set the TV station.  This selects on of the TV sta
#              tions  which  are  configured  in the .xawtv config			#
#              file.  The argument can be the station  name  or  a
#              number  (the first one listed in the config file is			#
#              0, ...).  next/prev jumps to the next/previous sta
#              tion  in  the list, back to the previously selected			#
#              one."
#Obviously, next, prev and back isn't too useful for us. YOU MUST CHANGE THIS FOR YOUR SYSTEM!
$channel="zdf";										#


											#
#now the pages.
#alevt-cap expects them in the form e.g. "112 113 115 702.00 702.01"			#
#where the two optional digit after a point indicate subpages
#the pages this script wants to process have to be in the following array		#
@pages = ("601","602","603","604","671","672","673","674","675","676");
#########################################################################################






getopts("cp");
#c : return channel name
#p : return pages

if ($opt_c) {
	print $channel;
	exit 0;
}
if ($opt_p) {
	print join(' ',@pages);
	exit 0;
}

$dir=$ENV{HOME}."/.vtticker";
$tempdir="${dir}/temp";
exit 1 if (! -d $tempdir);
#now the main loop
#the scheme is as follows:
#${dir}/temp/${channel}_${page}.{subpage}
#e.g. ~/vtticker/temp/ard_112.00
#subpage is optional, defaults to 00

#one html page as link
$link="${tempdir}/zdf-brsenkurse.html";
open (HTML,">$link") or die "Can't open file $link for writing: $!\n";
print HTML <<EOT;
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<HTML><HEAD><TITLE>Brsenkurse aus dem ZDF-Videotext</title></head>
<body>
EOT

foreach $pagenumber (@pages) {
	$page="${tempdir}/${channel}_${pagenumber}";
	if (-r $page) {
		my (@titles,@descriptions);
		open (PAGE,"<$page") or print STDERR "Can't open file $page for reading: $!\n",next;
		if ($pagenumber =~ /601/) {
LABEL1:			while (<PAGE>) {
				if (/^ *(\d{2}\.\d{2}\.\d{2})\, +(\d{2}\:\d{2} Uhr)/) {
					$titles[$#titles+1]="Deutsche Indizes vom ".$1.", ".$2.":";
					next;
				}
				if (/^ *DAX\.* +([\d\.]{5,10} +[\d\.+-]{3,10} +[\d\.+-]{3,5}\%)/) {
					$titles[$#titles+1]="DAX: ".$1;
					next;
				}
				if (/^ *Nemax 50\.* +([\d\.]{5,10} +[\d\.+-]{3,10} +[\d\.+-]{3,5}\%)/) {
					$titles[$#titles+1]="Nemax 50: ".$1;
					last LABEL1;
				}
			}
		} elsif ($pagenumber =~ /60[2-4]/) {
LABEL2:			while (<PAGE>) {
				if (/^ *DAX\.+/) {
					last LABEL2;
				}
				if (/^ *(\d{2}\.\d{2}\.\d{2})\, +(\d{2}\:\d{2} Uhr)/ and $pagenumber eq "602") {
					$titles[$#titles+1]="Deutsche Kurse vom ".$1.", ".$2.":";
					next;
				}
				if (/^ *([\w \.-]*?)(?>\.* +)([\d\.]{4,10} +[\d\.+-]{3,10} +[\d\.+-]{3,5}\%)/) {
					$titles[$#titles+1]="$1: ".$2;
					#$titles[$#titles+1]=~ s/  / /g;
					next;
				}
			}
		} elsif ($pagenumber =~ /671]/) {
LABEL3:			while (<PAGE>) {
				if (/^ *(\d{2}\.\d{2}\.\d{2})\, +(\d{2}\:\d{2} Uhr)/) {
					$titles[$#titles+1]="US-Indizes vom ".$1.", ".$2.":";
					next;
				}
				if (/^ *Dow Jones\.* +([\d\.]{5,10} +[\d\.+-]{3,10} +[\d\.+-]{3,5}\%)/) {
					$titles[$#titles+1]="Dow Jones: ".$1;
					next;
				}
				if (/^ *Nasdaq\.* +([\d\.]{5,10} +[\d\.+-]{3,10} +[\d\.+-]{3,5}\%)/) {
					$titles[$#titles+1]="Nasdaq: ".$1;
					last LABEL3;
				}
			}
		} elsif ($pagenumber =~ /67[2-6]/) {
############################
#at the moment I skip these US stocks because I'm not interested in them.
#Uncomment the next line to anable them.
############################
			next;
LABEL4:			while (<PAGE>) {
				if (/^ *Dow Jones\.+/) {
					last LABEL4;
				}
				if (/^ *(\d{2}\.\d{2}\.\d{2})\, +(\d{2}\:\d{2} Uhr)/ and $pagenumber eq "672") {
					$titles[$#titles+1]="US-Kurse vom ".$1.", ".$2.":";
					next;
				}
				if (/^ *([\w \.-]*?)(?>\.* +)([\d\.]{5,10} +[\d\.+-]{3,10} +[\d\.+-]{3,5}\%)/) {
					$titles[$#titles+1]="$1: ".$2;
					#$titles[$#titles+1]=~ s/  / /g;
					next;
				}
			}
		}
		foreach (0..$#titles) {
			print <<EOT;
			<item>
			<title>$titles[$_] </title>
			<link>$link</link>
			<description>$descriptions[$_] </description>
			</item>\n
EOT
#			print HTML $htmllink1st."<p>".$titles[$_]." ".$descriptions[$_]."</p>".$htmllink2nd."\n";
		}
		close PAGE;
	}
}

print HTML "</body></html>";
close HTML;





